/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import "Box.h"


@implementation Box

- initName:(NSString*)name width:(double)width height:(double)height
{
    self = [super init];
    _width = width;
    _height = height;
    _name = [name retain];
    return self;
}

- init
{
    return [self initName:nil width:1.0 height:1.0];
}

- (void) dealloc
{
    [_name release];
    [super dealloc];
}

- (NSString*)description
{
    return [NSString stringWithFormat:@"Box 0x%x {'%@' %f x %f}", self, _name, _width, _height];
}

@end
