/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import <Foundation/Foundation.h>

@class NSData, NSMutableData,IDLDefinitionScope;

@interface IDLParser:NSObject
{
    NSString* _filename;
    IDLDefinitionScope* rootScope;
    NSMutableSet* loadedFiles;  /* loaded files */
    NSMutableSet* idlFiles;
    NSMutableArray* _searchPaths;
	NSMutableDictionary* _ref;
    BOOL _root;
    BOOL isChanged;
}

+ rootParser;
- initByParsingIDLFiles:(NSArray*)files searchPaths:(NSArray*)array;

- (IDLDefinitionScope*)rootScope;
- (BOOL) isRoot;

- (void) loadFiles:(NSArray*)files;
- (void) addSearchPath:(NSString*)path;

- (BOOL) isDocumentEdited;
- (void) setDocumentEdited:(BOOL)flag;

- (NSString*) definedValueForKey:(NSString*)key;
- (void) defineValue:(NSString*)value forKey:(NSString*)key;
- (BOOL) doesDefine:(NSString*)key;
- (void) undefineValueForKey:(NSString*)key;

- (NSString*) locateFile:(NSString*)file directory:(NSString*)dir;
- (void) addToLoadedFiles:(NSString*)path;

- (void) setSourceFile:(NSString*)path forObject:object;
- (NSString*) sourceFileForObject:object;

// return filename if read from the model or nil
- (NSString*) filename;

// Save 'idlFiles' array
- (void) saveFilesTo:(NSString*)path;
// Save as a model
- (void) saveParserTo:(NSString*)path;
@end

@interface IDLParser(Viewer)
- (void) loadInterfacesWithTypes:(NSArray*)types window:window;
@end

