/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import <Foundation/Foundation.h>

@class VXConnection, CORBAObject,IDLFunction, VXMessage;

enum CORBA_Completion{
    CORBA_COMPLETION_NO,
    CORBA_COMPLETION_MAYBE,
    CORBA_COMPLETION_YES
};

@interface VXInvocation : NSObject
{
    IDLFunction* _function;
    NSMutableDictionary* _args;
    VXConnection* _connection;
    CORBAObject* _object;
	NSMutableDictionary* _requestContext;
	NSMutableDictionary* _responseContext;
	VXMessage* _response;
	NSConditionLock* _lock;
    long _requestId;
    unsigned char _replyStatus;
    unsigned char _completionStatus;
}

- initWith:(CORBAObject*)obj function:(IDLFunction*)func andArguments:(NSMutableDictionary*)args;
- (void) invoke;

- (NSTimeInterval) replyTimeout;
- (long) requestId;
- (void) setResponse:(VXMessage*)message;
- (VXConnection*) connection;
@end
